#ifndef INCLUDED_WIDGET_CONSTRUCTOR_H
#define INCLUDED_WIDGET_CONSTRUCTOR_H

class QWidget;

namespace gui
{

  /**
   * Erlaubt die verzgerte Konstruktion eines Widgets. Ein Objekt des Typs 
   * IWidgetConstructor enthlt alle Informationen die ntig sind um ein Widget
   * zu erzeugen.
   */
  class IWidgetConstructor
  {
  public:

    /**
     * Baut ein QWidget.
     * @param parent Der Parent des konstruierten Widgets.
     * @return ein neu erzeugtes Widget.
     */
    virtual QWidget* constructWidget(QWidget* parent) const = 0;

    /**
     * Zerstrt das Widget wieder. Darf nicht delete aufrufen!
	 * Die Methode ist dazu gedacht, eventuelle Registrierungen
	 * etc. des Widgets wieder rckgngig zu machen.
	 * delete wird in der PropertyView aufgerufen.
	 * @param w ein Pointer auf das von dem Constructor mit
	 *    constructWidget erzeugte Widget.
     */
    virtual void destroyWidget(QWidget* w) const = 0;
  };

} // end of namepsace gui

#endif
